﻿using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraComboEditorSetFocus
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraComboEditor1.SetDataBinding(this.GetData(), "table1");
            this.ultraComboEditor1.DisplayMember = "Name";
            this.ultraComboEditor1.AutoCompleteMode = Infragistics.Win.AutoCompleteMode.SuggestAppend;
            this.ultraComboEditor2.SetDataBinding(this.GetData(), "table1");
        }

        private void UltraButton_Click(object sender, EventArgs e)
        {
            UltraButton button = sender as UltraButton;
            if (button == null)
            {
                return;
            }

            UltraComboEditor editor;
            if (button.Name == "ultraButton1")
            {
                editor = this.ultraComboEditor1;
                this.CustomEditMode(editor);
            }

            if (button.Name == "ultraButton2")
            {
                editor = this.ultraComboEditor2;
                this.CustomEditMode(editor);
            }
        }

        private void CustomEditMode(UltraComboEditor editor)
        {
            editor.Focus();
            Rectangle editorRec = editor.ClientRectangle;
            Cursor.Position = editor.PointToScreen(new Point(editorRec.Left + 5, editorRec.Top + 5));
        }

        private void UltraComboEditor_AfterEnterEditMode(object sender, EventArgs e)
        {

        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            ds = AddData(ds);

            return ds;
        }

        private DataSet AddData(DataSet ds)
        {
            ds.Tables["table1"].Rows.Add(new object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new object[] { null, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            return ds;
        }
    }
}
